<?php

use App\Models\buyer;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\BuyerController;
use App\Http\Controllers\loginController;
use App\Http\Controllers\ReportController;
use App\Http\Controllers\SallerController;
use App\Http\Controllers\InvoiceController;
use App\Http\Controllers\ProductController;
use App\Http\Controllers\DashboardController;
use App\Http\Controllers\CategoriesController;
use App\Http\Controllers\DashboardContrroller;
use App\Http\Controllers\InvoiceUpdateContoller;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

// login page
Route::get('/login',[loginController::class,'login_page'])->name('login_page');


Route::get('/',function(){
    return redirect()->route('login_page');
});

Route::post('login_fun',[loginController::class,'login_fun'])->name('login_fun');

Route::middleware(['loginAuth'])->group(function(){

    Route::get('/dashboard', [DashboardContrroller::class, 'index'])->name('dashboard');
    Route::get('/', [DashboardContrroller::class, 'index'])->name('dashboard');
    Route::get('/reports',[ReportController::class,'index'])->name('reports');
    Route::get('/getReports',[ReportController::class,'getReports'])->name('getReports');
    // Route::get('/home', function () {
    //     return view('home')->with([
    //         'title' => 'home'
    //     ]);
    // })->name('home');

    Route::get('/logout',[loginController::class,'logout'])->name('logout');

    // ============= search buyer =================
    Route::get('/search_buyer',[BuyerController::class,'search_buyer'])->name('search_buyer');

    // ============= get all sallers ==============
    Route::get('/sallers',[SallerController::class,'sallers'])->name('sallers');

    // ============= add saller page ==============
    Route::get('/add_saller',[SallerController::class,'add_saller'])->name('add_saller');

    // ============= insert update saller ============
    Route::post('/insert_update_saller',[SallerController::class,'insert_update_saller'])->name('insert_update_saller');

    // ===================================================================================================================
    // ================== get all categories ================
    Route::get('/categories',[CategoriesController::class,'categories'])->name('categories');

    // ============= add category page ==============
    Route::get('/add_category',[CategoriesController::class,'add_category'])->name('add_category');

    // ============= edit category page ==============
    Route::get('/edit_category/{id}',[CategoriesController::class,'edit_category'])->name('edit_category');

    // ============= insert update saller ============
    Route::post('/insert_update_category',[CategoriesController::class,'insert_update_category'])->name('insert_update_category');

    // ============ show category ===============
    Route::get('/show_category/{id}',[CategoriesController::class,'show_category'])->name('show_category');

    // ============= delete category ============
    Route::get('/delete_category',[CategoriesController::class,'delete_category'])->name('delete_category');

    // ===================================================================================================================
    // ============= get all products and services ==========
    Route::get('/products',[ProductController::class,'products'])->name('products');

    // ============= add product page ==============
    Route::get('/add_product',[ProductController::class,'add_product'])->name('add_product');

    // ============= edit product page ==============
    Route::get('/edit_product/{id}',[ProductController::class,'edit_product'])->name('edit_product');

    // ============= insert update saller ============
    Route::post('/insert_update_product',[ProductController::class,'insert_update_product'])->name('insert_update_product');

    // ============ show product ===============
    Route::get('/show_product/{id}',[ProductController::class,'show_product'])->name('show_product');

    //============== hide product ==============
    Route::get('/hide_product',[ProductController::class,'hide_product'])->name('hide_product');

    // ============= delete product ============
    Route::get('/delete_product',[ProductController::class,'delete_product'])->name('delete_product');

    // ============================================================================================================================
    // ============= get list of invoices ==============
    Route::get('/invoices',[InvoiceController::class,'invoices'])->name('invoices');

    // ============ add new invoice ==============
    Route::get('/add_invoice',[InvoiceController::class,'add_invoice'])->name('add_invoice');

    // ============ insert update invoice ==========
    Route::post('/insert_update_invoice',[InvoiceController::class,'insert_update_invoice'])->name('insert_update_invoice');

    // ============ show invoice =================
    Route::get('/show_invoice/{id}',[InvoiceController::class,'show_invoice'])->name('show_invoice');

    // ============ print invoice ================
    Route::get('/print_invoice/{id}',[InvoiceController::class,'print_invoice'])->name('print_invoice');

    // ============ delete invoice ===============
    Route::get('/delete_invoice',[InvoiceController::class,'delete_invoice'])->name('delete_invoice');

    // ============ debit invoice  ===============
    Route::get('/debit_invoice/{id}/{update_type}',[InvoiceUpdateContoller::class,'debit_credit_invoice'])->name('debit_invoice');

    // ============ credit invoice ===============
    Route::get('/credit_invoice/{id}/{update_type}',[InvoiceUpdateContoller::class,'debit_credit_invoice'])->name('credit_invoice');

    // ============ get all debit invoices =============
    Route::get('/debits',[InvoiceUpdateContoller::class,'getDebits'])->name('get_debits');

    // ============ get all credit invoices =============
    Route::get('/credits',[InvoiceUpdateContoller::class,'getCredits'])->name('get_credits');

    // ============ show debit notification ============
    Route::get('/show_debit/{id}',[InvoiceUpdateContoller::class,'show_debit'])->name('show_debit');

    // ============ show credit notification ============
    Route::get('/show_credit/{id}',[InvoiceUpdateContoller::class,'show_credit'])->name('show_credit');

    // ============ debit update invoice ===============
    Route::post('/debit_update_invoice',[InvoiceUpdateContoller::class,'debit_update_invoice'])->name('debit_update_invoice');

    // ============ credit update invoice ===============
    Route::post('/credit_update_invoice',[InvoiceUpdateContoller::class,'credit_update_invoice'])->name('credit_update_invoice');

    // ============ print invoice after update  ==============
    Route::geT('/print_updated_invoice/{update_type}/{id}',[InvoiceUpdateContoller::class,'print_updated_invoice'])->name('print_updated_invoice');

    // ============ get products reated to this category
    Route::geT('/get_products',[ProductController::class,'get_products'])->name('get_products');

});
// Route::get('/test',function(){
//     dd(Hash::make('123'));
// });

